//+------------------------------------------------------------------+
//|                                                 PriceTrender.mq4 |
//|                                                          Kalenzo |
//|                                      bartlomiej.gorski@gmail.com |
//|			http://www.fxservice.eu |
//+------------------------------------------------------------------+
#property copyright "Kalenzo"
#property link      "bartlomiej.gorski@gmail.com, http://www.fxservice.eu"
#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 DodgerBlue
#property indicator_color2 Gold
#property indicator_color3 Magenta
#property indicator_color4 Aqua


// Use short MA lengths for testing purposes

extern int TimeFrame = 30,
           Price = 0,
           MaType = 0,
           MaPrice = 0,
           MaLength = 24;
           

double price[], trend[], trendUp[], trendDn[];
 
 

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
IndicatorBuffers(4);
SetIndexBuffer(0,price);
SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,0);

SetIndexBuffer(1,trend);
SetIndexStyle(1,DRAW_LINE,STYLE_SOLID,0);

SetIndexBuffer(2,trendDn);
SetIndexStyle(2,DRAW_ARROW,0);
SetIndexArrow(2,108);

SetIndexBuffer(3,trendUp);
SetIndexStyle(3,DRAW_ARROW,0);
SetIndexArrow(3,108);

    
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    limit, bigshift; 
   int    counted_bars=IndicatorCounted(); 
//---- 
   if (counted_bars<0) return(-1); 
   if (counted_bars>0) counted_bars--; 
   limit=Bars-counted_bars; 
  
   for (int i=limit; i>=0; i--) 
	{
		bigshift = iBarShift(Symbol(),TimeFrame,Time[i]); 
		
		double tprice = getPrice(bigshift);
		double ttrend = iMA(Symbol(),TimeFrame,MaLength,0,MaType,MaPrice,bigshift);
		
		price[i] = tprice;
		trend[i] = ttrend;
		
		if(price[i+1] > trend[i+1] && price[i] < trend[i])
		{
			trendDn[i] = High[i] + 3*Point;
		}
		
		if(price[i+1] < trend[i+1] && price[i] > trend[i])
		{
			trendUp[i] = Low[i] - 3*Point;
		}
	}
			
  return(0);
  } 
//+------------------------------------------------------------------+


double getPrice(int shift)
{
   switch(Price)
   {
      case 0 : return ( iClose(Symbol(),TimeFrame,shift) );
      case 1 : return (iOpen(Symbol(),TimeFrame,shift));
      case 2 : return (iHigh(Symbol(),TimeFrame,shift));
      case 3 : return (iLow(Symbol(),TimeFrame,shift));
      case 4 : return ((iLow(Symbol(),TimeFrame,shift)+iHigh(Symbol(),TimeFrame,shift))/2);
      case 5 : return ((iClose(Symbol(),TimeFrame,shift)+iLow(Symbol(),TimeFrame,shift)+iHigh(Symbol(),TimeFrame,shift))/3);
      case 6 : return ((iOpen(Symbol(),TimeFrame,shift)+iClose(Symbol(),TimeFrame,shift)+iLow(Symbol(),TimeFrame,shift)+iHigh(Symbol(),TimeFrame,shift))/4);
   }
}